// Octave-band Spectrum Analyzer and CPU Heater, by PRC, March 2008
BPF b[10];
gain g[10];
OnePole p[10];
["20Hz","40Hz","80Hz","160Hz","320Hz",
	"640Hz","1280Hz","2.5kHz","5kHz","10kHz"] @=> string names[];

Noise n;
BPF b2[10];

MAUI_View myWinder;
myWinder.size(250.0,550.0);
MAUI_Slider disp[10];

10.0 => adc.gain;		// global gain adjustment

for (0=>int i;i<10;1+=>i)	{
    adc => b[i] => g[i] => p[i] => blackhole;
	n => b2[i] => dac;
    b[i] => g[i];		// make a
    3 => g[i].op;		// squarer
    0.9995 => p[i].pole; // and smoothing filter
    2.0 => b[i].Q => b2[i].Q;
    20.0 * Math.pow(2.0,i) => b[i].freq => b2[i].freq; // octave bands
    disp[i].position(0.0,50.0*i);
    disp[i].range(0.0,1.0);
	disp[i].name(names[i]);
    myWinder.addElement(disp[i]);
}

myWinder.display();

while (1)	{
    0.02 :: second => now;
	for (0=>int i;i<10;1+=>i) 	{
		0.5 * (Math.log10(p[i].last() + 0.01) + 2.0) => disp[i].value;
		p[i].last() => b2[i].gain;
	}
}
